Bug 249063 - readahead does not readahead
readahead does not readahead
Status: CLOSED WONTFIX
Product: Fedora
Classification: Fedora
Component: readahead (Show other bugs)
7
i386 Linux
low Severity high
: ---
: ---
Assigned To: Karel Zak
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-07-20 13:40 EDT by Hasan Ceylan
Modified: 2008-06-16 21:55 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2008-06-16 21:55:49 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Hasan Ceylan 2007-07-20 13:40:05 EDT
Description of problem:
Readahead later does not cache

Version-Release number of selected component (if applicable):
readahead-1.4.1-2.fc7

How reproducible:
everytime

Steps to Reproduce:
1. Boot
2. Check the output of free
  
Actual results:
less then 64M in page cache

Expected results:
A lot more

Additional info:
I downloaded the src rpm and changed the line ~352

readahead(fd, 0, file->size);

to 

while (read(fd, &buff[0], sizeof(buff)) == sizeof(buff));

Now, I know that this looks ugly, but for some reason readahead function does
not do the trick. When I changed to actual reading it, it work flawlessly. 

I have about custom tailored later.sorted, and I do not see a noticable
degradation of performance...

Regards,
Hasan Ceylan
Comment 1 Hasan Ceylan 2007-08-14 14:47:59 EDT
Hello,

It is about a month and no response yet. 

As Fedora community users we also put efforts to make RH products better ones
and in return expect our comments and patches to be reviewed.

Regards,
Hasan Ceylan  
Comment 2 Karel Zak 2007-08-14 16:08:25 EDT
Sorry, but the patch is nonsense. The readahead() syscall has to work or has to
be fixed -- any other way is wrong.

I have tried (few months ago) to monitor readahead by bootchart
(http://www.bootchart.org/) and it works.

My plan is to check readahead stuff and generate bootcharts during F8
development -- so, please, be patient :-)
Comment 3 Hasan Ceylan 2007-08-15 04:33:17 EDT
Dear Carel,

Thanks for your response. If my message has been too harsh please accept my
apologies.

First I should make some clarifications
-I did not mean that my patch must make its way to the main source
-I specifically said "this hack is ugly" but is a working workaround
-I did not expect (and asked) a working solution on the next day I created the
bug report

The bug remained as NEW up until yesterday. What I was unhappy with was, there
was no attention to the bug, nor a comment. (...At least visible to me)

Now, back to the issue:
Please bear with me that I am no kernel expert. But what I understand from
kernel readahead implementation is, it reads n blocks further from the actual
sector on the disk only for the means to push it to the cache. If so, and also
if our requirement is to force fs to read the entire file, do we really need to
rely on readahead in kernel? I know that reading the file has the overhead of
some buffer copying to the userland, but I think the added processing cost there
might be ignored as it does not account much. 

Again I do not strictly say, we should *read*, but if kernel readahead is broken
/ likely to be broken in the future just reading the file makes sense.

Regards,
Hasan Ceylan  
Comment 4 Bug Zapper 2008-05-14 09:37:03 EDT
This message is a reminder that Fedora 7 is nearing the end of life. Approximately 30 (thirty) days from now Fedora will stop maintaining and issuing updates for Fedora 7. It is Fedora's policy to close all bug reports from releases that are no longer maintained. At that time this bug will be closed as WONTFIX if it remains open with a Fedora 'version' of '7'.

Package Maintainer: If you wish for this bug to remain open because you plan to fix it in a currently maintained version, simply change the 'version' to a later Fedora version prior to Fedora 7's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that we may not be able to fix it before Fedora 7 is end of life. If you would still like to see this bug fixed and are able to reproduce it against a later version of Fedora please change the 'version' of this bug. If you are unable to change the version, please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's lifetime, sometimes those efforts are overtaken by events. Often a more recent Fedora release includes newer upstream software that fixes bugs or makes them obsolete. If possible, it is recommended that you try the newest available Fedora distribution to see if your bug still exists.

Please read the Release Notes for the newest Fedora distribution to make sure it will meet your needs:
http://docs.fedoraproject.org/release-notes/

The process we are following is described here: http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 5 Bug Zapper 2008-06-16 21:55:47 EDT
Fedora 7 changed to end-of-life (EOL) status on June 13, 2008. 
Fedora 7 is no longer maintained, which means that it will not 
receive any further security or bug fix updates. As a result we 
are closing this bug. 

If you can reproduce this bug against a currently maintained version 
of Fedora please feel free to reopen this bug against that version.

Thank you for reporting this bug and we are sorry it could not be fixed.

Note You need to log in before you can comment on or make changes to this bug.